Subject: Improve behaviour when mime type detection is missing
Description

When no library is available for doing mime type detection, information like the dimensions of images is not indexed. This leads to
several problems e.g. in the frontend output.

To better cope with such a situation, we should have

    1. a reports module that tests if mime type detection works
    2. a heuristic that tries to guess the file type if no mime type can be extracted (we might as well have a fixed list of file extensions as
was suggested in the comments for #46020)

Related issues:
related to Core - Bug # 46020: Image size is 0 when not scaled Closed 2013-03-04
duplicates Core - Feature # 60019: Create utility function to get the file mi... Resolved 2014-07-01

Associated revisions
Revision e372399b - 2015-02-02 21:38 - Sascha Egerer 

[FEATURE] Add SplFileInfo implementation to get file mimeType

\TYPO3\CMS\Core\Type\File\FileInfo provides a new method
getMimeType() to get the MIME type of a file, e.g. text/html.

Custom implementations to determine the MIME type can be added
with the hook:

$GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS'][\TYPO3\CMS\Core\Type\File\FileInfo::class]['mimeTypeGuessers']

The FAL LocalDriver also uses this new API.

Resolves: #60019
Releases: master
Tested-by: Steffen Müller <typo3@t3node.com>
Reviewed-by: Steffen Müller <typo3@t3node.com>

History
#1 - 2013-04-01 16:34 - Helmut Hummel

Andreas Wolf wrote:

When no library is available for doing mime type detection, information like the dimensions of images is not indexed. This leads to several
problems e.g. in the frontend output.

To better cope with such a situation, we should have
    1. a reports module that tests if mime type detection works
    2. a heuristic that tries to guess the file type if no mime type can be extracted (we might as well have a fixed list of file extensions as was
suggested in the comments for #46020)

    1. A Hook (or signal) for the mime type detection, as it might be useful to set mime types for "own" file suffixes.

#2 - 2015-01-15 11:22 - Mathias Schreiber
- Sprint Focus set to On Location Sprint

#3 - 2015-01-29 11:50 - Frans Saris

A signal should be added to LocalDriver::getMimeTypeOfFile()

Something like:

    /**
     * Get MIME type of file.
     *
     * @param string $absoluteFilePath Absolute path to file
     * @return string|boolean MIME type. eg, text/html, FALSE on error
     */
    protected function getMimeTypeOfFile($absoluteFilePath) {        
        $mimeType = FALSE;
        if (function_exists('finfo_file')) {
            $fileInfo = new \finfo();
            $mimeType = $fileInfo->file($absoluteFilePath, FILEINFO_MIME_TYPE);
        } elseif (function_exists('mime_content_type')) {
            $mimeType = mime_content_type($absoluteFilePath);
        }

        $this->emitGetMimeTypeOfFileSignal($absoluteFilePath, $mimeType);

        return $mimeType;
    }

    /**
     * @param $absoluteFilePath
     * @param $mimeType
     */
    protected function emitGetMimeTypeOfFileSignal($absoluteFilePath, &$mimeType) {
        $this->signalSlotDispatcher->dispatch(self::class, self::SIGNAL_GetMimeTypeOfFile, array($this, $absoluteFilePath, $mimeType));
    }

#4 - 2015-01-29 12:26 - Mathias Schreiber
- Status changed from Accepted to New

#5 - 2015-01-29 12:28 - Frans Saris
- Status changed from New to In Progress

#6 - 2015-01-29 15:22 - Gerrit Code Review
- Status changed from In Progress to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/36358

#7 - 2015-01-30 11:19 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/36358

#8 - 2015-02-01 09:57 - Mathias Schreiber
- Status changed from Under Review to Closed
